## ros-indigo-controller-manager 0.9.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(controller_manager)

# Load catkin and all dependencies required for this package
find_package(catkin REQUIRED COMPONENTS controller_interface controller_manager_msgs hardware_interface realtime_tools pluginlib)

include_directories(include ${Boost_INCLUDE_DIR} ${catkin_INCLUDE_DIRS})

# Declare catkin package
catkin_package(
  DEPENDS boost
  CATKIN_DEPENDS controller_interface controller_manager_msgs hardware_interface realtime_tools pluginlib
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME}
  )

add_library(${PROJECT_NAME}
  src/controller_manager.cpp
  include/controller_manager/controller_manager.h
  include/controller_manager/controller_loader_interface.h
  include/controller_manager/controller_loader.h
)
target_link_libraries(${PROJECT_NAME} ${catkin_LIBRARIES} ${Boost_LIBRARIES})

if(catkin_EXPORTED_TARGETS)
  add_dependencies(${PROJECT_NAME} ${catkin_EXPORTED_TARGETS})
endif()

if(CATKIN_ENABLE_TESTING)

  find_package(rostest REQUIRED)
  add_rostest_gtest(controller_manager_hwi_switch_test
    test/hwi_switch_test.test
    test/hwi_switch_test.cpp
  )
  target_link_libraries(controller_manager_hwi_switch_test ${PROJECT_NAME} ${catkin_LIBRARIES})

endif()

# Install
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(TARGETS ${PROJECT_NAME}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

install(PROGRAMS scripts/spawner scripts/unspawner scripts/controller_manager
  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

catkin_python_setup()

=== debian/changelog ===
ros-indigo-controller-manager (0.9.7-0trusty) trusty; urgency=high

  * Introduce shared_ptr typedefs
  * Contributors: Bence Magyar

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Fri, 18 May 2018 23:00:00 -0000

ros-indigo-controller-manager (0.9.6-0trusty) trusty; urgency=high

  * Fix controller_manager_interface and add unit tests.
  * Contributors: Yong Li

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 15 Apr 2018 23:00:00 -0000

ros-indigo-controller-manager (0.9.5-0trusty) trusty; urgency=high



 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 25 Mar 2018 23:00:00 -0000

ros-indigo-controller-manager (0.9.4-0trusty) trusty; urgency=high

  * Fix doSwitch execution point
    The doSwitch method needs to be executed in the update() method,  that is, in
    the real-time path, which is where controller switching actually takes place.
    It was previously done in the switchController callback, which is non real-time.
    In this method controller switching is scheduled, but not actually executed.
    This changeset fixes a bug in which hardware interface  modes could switch
    before controllers, leading to undefined behavior.
  * Introduce prepareSwitch, replacement of canSwitch
    RobotHW::prepareSwitch is intended as a substitute for RobotHW::canSwitch.
    The main reasons for the change are a non-const signature to allow
    changing state and a more descriptive name.
    RobotHW::canSwitch will be deprecated in a later ROS distro.
  * Address -Wunused-parameter warnings
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Mathias Lüdtke

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Fri, 12 Feb 2016 00:00:00 -0000

ros-indigo-controller-manager (0.9.3-0trusty) trusty; urgency=high

  * controller_manager: Add missing rostest dep
  * Contributors: Adolfo Rodriguez Tsouroukdissian

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 04 May 2015 23:00:00 -0000

ros-indigo-controller-manager (0.9.2-0trusty) trusty; urgency=high

  * Add HW interface switch feature
  * Contributors: Mathias Lüdtke

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Sun, 03 May 2015 23:00:00 -0000

ros-indigo-controller-manager (0.9.1-0trusty) trusty; urgency=high

  * Update package maintainers
  * Contributors: Adolfo Rodriguez Tsouroukdissian

 -- Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>  Mon, 03 Nov 2014 00:00:00 -0000

ros-indigo-controller-manager (0.9.0-0trusty) trusty; urgency=high

  * Spawner script: adding shutdown timeout to prevent deadlocks
  * Documentation fixes
  * Contributors: Jonathan Bohren, shadowmanos

 -- Wim Meeussen <wim@hidof.com>  Fri, 31 Oct 2014 00:00:00 -0000

ros-indigo-controller-manager (0.8.2-0trusty) trusty; urgency=high



 -- Wim Meeussen <wim@hidof.com>  Tue, 24 Jun 2014 23:00:00 -0000

ros-indigo-controller-manager (0.8.1-0trusty) trusty; urgency=high



 -- Wim Meeussen <wim@hidof.com>  Mon, 23 Jun 2014 23:00:00 -0000

ros-indigo-controller-manager (0.8.0-0trusty) trusty; urgency=high

  * Remove rosbuild artifacts. Fix #154 <https://github.com/ros-controls/ros_control/issues/154>.
  * Create README.md
  * Contributors: Adolfo Rodriguez Tsouroukdissian

 -- Wim Meeussen <wim@hidof.com>  Sun, 11 May 2014 23:00:00 -0000

ros-indigo-controller-manager (0.7.2-0trusty) trusty; urgency=high



 -- Wim Meeussen <wim@hidof.com>  Mon, 31 Mar 2014 23:00:00 -0000

ros-indigo-controller-manager (0.7.1-0trusty) trusty; urgency=high



 -- Wim Meeussen <wim@hidof.com>  Sun, 30 Mar 2014 23:00:00 -0000

ros-indigo-controller-manager (0.7.0-0trusty) trusty; urgency=high

  * Add --timeout option to controller spawner
  * Use argparse instead of getopt
    It is a much nicer interface
  * Contributors: Paul Mathieu

 -- Wim Meeussen <wim@hidof.com>  Fri, 28 Mar 2014 00:00:00 -0000

ros-indigo-controller-manager (0.6.0-0trusty) trusty; urgency=high

  * Update controller_manager.cpp
    Postfix to prefix increment operator.
  * Contributors: Adolfo Rodriguez Tsouroukdissian

 -- Wim Meeussen <wim@hidof.com>  Wed, 05 Feb 2014 00:00:00 -0000

ros-indigo-controller-manager (0.5.8-0trusty) trusty; urgency=high

  * Fixed additional timeout that was just added
  * Merge branch 'hydro-devel' into extended_wait_time
  * Extended wait time to 30 seconds for slower computers
  * Renamed manifest.xml to prevent conflicts with rosdep
  * Fix broken unspawner script.
  * Check controller_manager API early. Fast shutdown.
    - Check for all services required by spawner at the beginning, so it can know
    early on that it has all its requisites.
    - Remove service waiting from shutdown to ensure a fast teardown.
    Usecase: A spawner that dies after the controller manager should not wait
    for services to appear as they will never appear, the controllers are already
    stopped. This happens for example when killing a Gazebo session.
  * Restore controller stop+unload on node kill.
    - Fixes #111 <https://github.com/ros-controls/ros_control/issues/111>.

 -- Wim Meeussen <wim@hidof.com>  Thu, 10 Oct 2013 23:00:00 -0000

ros-indigo-controller-manager (0.5.7-0trusty) trusty; urgency=high

  * Update controller_manager.cpp
    getControllerNames now clears names before adding current names.  This fixes a bug in reloadControllerLibrariesSrv where the method is called twice in a row without first clearing the list.
    Steps to reproduce:
    - Spawn controller
    - Stop controller
    - reload-libraries
    controller_manager.cpp:501: bool controller_manager::ControllerManager::reloadControllerLibrariesSrv(controller_manager_msgs::ReloadControllerLibraries::Request&, controller_manager_msgs::ReloadControllerLibraries::Response&): Assertion `controllers.empty()' failed.
  * Updated changelogs

 -- Wim Meeussen <wim@hidof.com>  Mon, 29 Jul 2013 23:00:00 -0000



=== debian/control ===
Source: ros-indigo-controller-manager
Section: misc
Priority: extra
Maintainer: Adolfo Rodriguez Tsouroukdissian <adolfo.rodriguez@pal-robotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-indigo-catkin, ros-indigo-controller-interface, ros-indigo-controller-manager-msgs, ros-indigo-hardware-interface, ros-indigo-pluginlib, ros-indigo-realtime-tools, ros-indigo-rostest
Homepage: https://github.com/ros-controls/ros_control/wiki
Standards-Version: 3.9.2

Package: ros-indigo-controller-manager
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-indigo-controller-interface, ros-indigo-controller-manager-msgs, ros-indigo-hardware-interface, ros-indigo-pluginlib, ros-indigo-realtime-tools, ros-indigo-rostest
Description: The controller manager.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-controller-manager//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
